'------------------------------------------------ about
'FILEBOX 4 CMM2 - thehark0@gmail.com - 08/2020
'Version Alpha 0.19 - Firmware 5.0504



'------------------------------------------------ init sys
init:
  chdir"\\"
  mode 1
  cls

  black=rgb(0,0,0)
  white=rgb(255,255,255)
  red=rgb(255,0,0)
  cian=rgb(0,255,255)
 


'------------------------------------------------ vars
vars:
  const title$="FILEBOX 4 CMM2 Alpha 0.19 - thehark0@gmail.com - 08/2020"

  dim listado_a$(256)
  dim listado_b$(256)
  dim listado_ok_a$(256)
  dim listado_ok_b$(256)
  dim listado_cut_a(256)
  dim listado_cut_b(256)

  for n=0 to 255
    listado_a$(n)=""
    listado_b$(n)=""
    listado_ok_a$(n)=""
    listado_ok_b$(n)=""
    listado_cut_a(n)=0
    listado_cut_b(n)=0
  next n

  cursor_a=0
  cursor_b=0

  columna_a=3
  columna_b=30

  indice_a=0
  indice_b=0

  limite_a=37
  limite_b=37

  ancho_a=25
  ancho_b=70

  max_listado_a=0
  max_listado_b=0

  limite_sobrepasado_a=0
  limite_sobrepasado_b=0

  panel=0  


  dim path_completo$(256)

  for n=0 to 255
    path_completo$(n)=""
  next n

  path_actual$="/"
  carpeta_actual=0
  
  wait_for_confirmation=0  
  extension$=""
  fichero$=""

    

'------------------------------------------------ run app
run_app:
  read_data()
  
  render_screen()
  render_path()
  render_list_a()
  render_list_b()
  render_cursor_a()



'------------------------------------------------ main loop
main_loop:
  render_footer()

  if wait_for_confirmation=1 then
    if keydown(1)=89 then
      wait_for_confirmation=0
      if post_action=1 then 'DELETE
'        if MM.ERRORNO=97 then
  '        on error clear
'          cls
'          print"cagada"
'          end
'        endif
'        on error skip 104
        rmdir listado_ok_a$(indice_a+cursor_a)
'        print "*"+str$(MM.ERRORNO)
'        print MM.ERRORMSG$
'        end
        
        post_action=0
        read_data()
        reload_screen()
      endif

      if post_action=3 then 'EDIT
        wait_for_confirmation=0
        post_action=0
'        on error skip
        EDIT listado_ok_b$(indice_a+cursor_a)       
      endif

      if post_action=4 then 'VIEW
        wait_for_confirmation=0
        post_action=0
        cls
        extension$=right$(listado_ok_b$(indice_b+cursor_b),4)

        if extension$=".JPG" then
          load JPG listado_ok_b$(indice_a+cursor_a)                 
          end
        else
          LIST listado_ok_b$(indice_a+cursor_a)       
        endif

        reload_screen()              
      endif

    endif

    if keydown(1)=78 then
        wait_for_confirmation=0
        post_action=0
        reload_screen()
    endif

    goto main_loop
  endif


    if keydown(1)=154 then  'F10
      cls
      print "Exit from FileBox 4 CMM2."
      print "Version Alpha 0.19"+chr$(10)      
      pause 200
      end
    endif

    if keydown(1)=145 then  'F1
      pantalla_help()
      reload_screen()
      pause 200
    endif

    if keydown(1)=148 then  'F4 / delete folder * VIEW
      if panel=0 then
        text 1*8,47*12,"Confirm DELETE selected Folder (Y/N).","L",1,1,red,black          
        wait_for_confirmation=1
        post_action=1 'DELETE
      endif
      if panel=1 then
        text 1*8,47*12,"Confirm VIEW selected File (Y/N).","L",1,1,cian,black          
        wait_for_confirmation=1
        post_action=4 'VIEW      
      endif
      pause 200
    endif

    if keydown(1)=146 then  'F2 / new folder * RUN
      if panel=0 then
        text 1*8,47*12,"Enter name for NEW Folder (Empty & Return to cancel): ","L",1,1,cian,black  
        input "",new_folder$      
        text 1*8,47*12,space$(98),"L",1,1,white,black  
        if new_folder$="" then
        
        else
          on error ignore
          mkdir new_folder$
          on error abort
          read_data()
          reload_screen()          
        endif
      endif

      if panel=1 then
        text 1*8,47*12,"Confirm RUN selected File (Y/N).","L",1,1,cian,black          
        wait_for_confirmation=1
        post_action=2 'RUN     
      endif
      pause 200
    endif

    if keydown(1)=147 then  'F3 / rename folder * edit
      if panel=0 then
        text 1*8,47*12,"Enter NEW name for selected Folder (Empty & Return to cancel): ","L",1,1,cian,black  
        input "",name_folder$      
        text 1*8,47*12,space$(98),"L",1,1,white,black  
        if name_folder$="" then
        
        else
          on error ignore
          rename listado_ok_a$(indice_a+cursor_a) AS name_folder$
          on error abort
          read_data()
          reload_screen()          
        endif
      endif

      if panel=1 then
        text 1*8,47*12,"Confirm EDIT selected File (Y/N).","L",1,1,cian,black          
        wait_for_confirmation=1
        post_action=3 'EDIT      
      endif
      pause 200
    endif

    if keydown(1)=149 then  'F5 / rename file
      if panel=1 then
        text 1*8,47*12,"Enter NEW name for selected File (Empty & Return to cancel): ","L",1,1,cian,black  
        input "",name_file$      
        text 1*8,47*12,space$(98),"L",1,1,white,black  
        if name_file$="" then
        
        else
          on error ignore
          rename listado_ok_b$(indice_b+cursor_b) AS name_file$
          on error abort
          read_data()
          reload_screen()          
        endif
      endif
      pause 200
    endif

    if keydown(1)=153 then  'F9 RELOAD
      panel=0
      read_data()
      reload_screen()
      pause 200
    endif

    if keydown(1)=10 then  'RETURN
      control_key_return()
      pause 200
    endif

    if keydown(1)=9 then  'TAB
      cambio_panel()
      pause 200
    endif

    if keydown(1)=128 then  'Cursor UP
      up()
      pause 200
    endif

    if keydown(1)=129 then  'Cursor DOWN
      down()
      pause 200
    endif

  goto main_loop



'------------------------------------------------ read data
sub read_data()
  carpetas$ = dir$("", dir)
  contador_a=0

  if carpetas$="" then
    listado_a$(contador_a)="<..>"
    contador_a=1
  else
    if carpeta_actual>0 then
      listado_a$(contador_a)="<..>"
      contador_a=1
    endif

    do while carpetas$<>""
      listado_a$(contador_a)=carpetas$
      contador_a=contador_a+1
      carpetas$ = dir$()    
    loop
  endif
  
  ficheros$ = dir$("*.*", file)
  contador_b=0

  if ficheros$="" then
    listado_b$(contador_b)="No files"
    contador_b=1
  else
    do while ficheros$<>""
      listado_b$(contador_b)=ficheros$
      contador_b=contador_b+1
      ficheros$ = dir$()    
    loop   
  endif

  for n=0 to 255
    listado_ok_a$(n)=""
    listado_ok_b$(n)=""
    listado_cut_a(n)=0
    listado_cut_b(n)=0
  next n

  cursor_a=0
  cursor_b=0

  indice_a=0
  indice_b=0

  max_listado_a=contador_a
  max_listado_b=contador_b

  limite_sobrepasado_a=0
  limite_sobrepasado_b=0

  if max_listado_a>limite_a then
    limite_sobrepasado_a=1
  endif

  if max_listado_b>limite_b then
    limite_sobrepasado_b=1
  endif
  
  for n=0 to max_listado_a
    if len(listado_a$(n))>ancho_a then
      listado_ok_a$(n)=left$(listado_a$(n),ancho_a)
      listado_cut_a(n)=1
    else
      listado_ok_a$(n)=listado_a$(n)
      listado_cut_a(n)=0
    endif
  next n

  for n=0 to max_listado_b
    if len(listado_b$(n))>ancho_b then
      listado_ok_b$(n)=left$(listado_b$(n),ancho_b)
      listado_cut_b(n)=1
    else
      listado_ok_b$(n)=listado_b$(n)
      listado_cut_b(n)=0
    endif
  next n
end sub



'------------------------------------------------ reload screen
sub reload_screen() 
  render_screen()
  render_path()
  render_list_a()
  render_list_b()

  if panel=0 then
    render_cursor_a()
  else
    render_cursor_b()
  endif
end sub



'------------------------------------------------ cambio panel
sub cambio_panel()
  if panel=0 and max_listado_b>0 and listado_ok_b$(indice_b+cursor_b)="No files" then
    exit sub
  endif

  text 22*8,49*12,space$(45),"L",1,1,white,black     ' buttons

  
  if panel=0 then
    delete_cursor_a()
'      text (columna_a*8)-(8*1),(4*12)+(cursor_a*12),chr$(254),"L",1,1,white,black
    panel=1
    render_cursor_b()
  else
    delete_cursor_b()
'      text (columna_b*8)-(8*1),(4*12)+(cursor_b*12),chr$(254),"L",1,1,white,black
    panel=0
    render_cursor_a()
  endif
end sub



'------------------------------------------------ control key return
sub control_key_return()
  if panel=0 then
    if listado_ok_a$(indice_a+cursor_a)="<..>" then
      carpeta_actual=carpeta_actual-1
      path_completo$(carpeta_actual)=""

      chdir ".."  
    else
      path_completo$(carpeta_actual)=listado_ok_a$(indice_a+cursor_a)
      chdir listado_ok_a$(indice_a+cursor_a)
      carpeta_actual=carpeta_actual+1
    endif    

    read_data()
    reload_screen()
  else
'    control_file_action()

  endif
end sub



'------------------------------------------------ control file action
sub control_file_action()
end sub



'------------------------------------------------ up
sub up()
  if panel=0 then
    if cursor_a=0 then
      if indice_a>0 then
        clear_list_a()
        indice_a=indice_a-1
        render_list_a()        
        render_cursor_a()
      endif
      exit sub
    endif
    delete_cursor_a()
    cursor_a=cursor_a-1
    render_cursor_a()
  endif

  if panel=1 then
    if cursor_b=0 then
      if indice_b>0 then
        clear_list_b()
        indice_b=indice_b-1
        render_list_b()        
        render_cursor_b()
      endif
      exit sub
    endif
    delete_cursor_b()
    cursor_b=cursor_b-1
    render_cursor_b()
  endif
end sub



'------------------------------------------------ down
sub down()
  if panel=0 then
    if max_listado_a<=limite_a then
      if cursor_a<max_listado_a-1 then
        delete_cursor_a()
        cursor_a=cursor_a+1 
        render_cursor_a()
      endif
      exit sub
    endif

    if cursor_a=limite_a-1 then
      if (indice_a+cursor_a)<max_listado_a-1 then
        clear_list_a()
        indice_a=indice_a+1
        render_list_a()
        render_cursor_a()
      endif   
      exit sub
    endif      
    delete_cursor_a()
    cursor_a=cursor_a+1 
    render_cursor_a()
  endif

  if panel=1 then
    if max_listado_b<=limite_b then
      if cursor_b<max_listado_b-1 then
        delete_cursor_b()
        cursor_b=cursor_b+1 
        render_cursor_b()
      endif
      exit sub
    endif

    if cursor_b=limite_b-1 then
      if (indice_b+cursor_b)<max_listado_b-1 then
        clear_list_b()
        indice_b=indice_b+1
        render_list_b()
        render_cursor_b()
      endif   
      exit sub
    endif  
    delete_cursor_b()
    cursor_b=cursor_b+1 
    render_cursor_b()
  endif
end sub



'------------------------------------------------ delete cursor a
sub delete_cursor_a()
  text (columna_a*8)-(8*1),(4*12)+(cursor_a*12),space$(24),"L",1,1,white,black
  text (columna_a*8)-(8*1),(4*12)+(cursor_a*12)," "+listado_ok_a$(indice_a+cursor_a)+" ","L",1,1,white,black

  text 5*8,45*12,space$(91),"L",1,1,white,black

'  text 22*8,49*12,space$(45),"L",1,1,white,black     ' buttons
end sub



'------------------------------------------------ delete cursor b
sub delete_cursor_b()
  text (columna_b*8)-(8*1),(4*12)+(cursor_b*12),space$(69),"L",1,1,white,black
  text (columna_b*8)-(8*1),(4*12)+(cursor_b*12)," "+listado_ok_b$(indice_b+cursor_b)+" ","L",1,1,white,black

  text 5*8,45*12,space$(91),"L",1,1,white,black

'  text 22*8,49*12,space$(45),"L",1,1,white,black     ' buttons
end sub



'------------------------------------------------ render cursor a
sub render_cursor_a()
  text (columna_a*8)-(8*1),(4*12)+(cursor_a*12)," "+listado_ok_a$(indice_a+cursor_a)+" ","L",1,1,black,white

'  posx=MM.INFO(HPOS)/8
'  for n=posx to 25
'    text (n*8),(4*12)+(cursor_a*12),"#","L",1,1,white,black
'  next n

  text 1*8,45*12,"Folder:","L",1,1,black,white

'  text columna_a*8,190,str$(limite_sobrepasado_a),"L",1,1,white,black
'  text columna_b*8,190,str$(limite_sobrepasado_b),"L",1,1,white,black

  text 9*8,45*12,listado_ok_a$(indice_a+cursor_a),"L",1,1,white,black
  text 1*8,42*12,str$((indice_a+cursor_a)+1)+"/"+str$(max_listado_a)+" ","L",1,1,white,black
  text 28*8,42*12,str$((indice_b+cursor_b)+1)+"/"+str$(max_listado_b)+" ","L",1,1,white,black
end sub



'------------------------------------------------ render cursor b
sub render_cursor_b()
  text (columna_b*8)-(8*1),(4*12)+(cursor_b*12)," "+listado_ok_b$(indice_b+cursor_b)+" ","L",1,1,black,white
  text 1*8,45*12,"File:","L",1,1,black,white

'  text columna_a*8,190,str$(limite_sobrepasado_a),"L",1,1,white,black
'  text columna_b*8,190,str$(limite_sobrepasado_b),"L",1,1,white,black

  text 7*8,45*12,listado_ok_b$(indice_b+cursor_b),"L",1,1,white,black
  text 1*8,42*12,str$((indice_a+cursor_a)+1)+"/"+str$(max_listado_a)+" ","L",1,1,white,black
  text 28*8,42*12,str$((indice_b+cursor_b)+1)+"/"+str$(max_listado_b)+" ","L",1,1,white,black
end sub



'------------------------------------------------ clear list a
sub clear_list_a:
  for n=4 to 40                                   ' bloque folder
    text 8*2,n*12,space$(24),"L",1,1,white,black
  next n

  text 8*8,45*12,space$(91),"L",1,1,white,black
end sub



'------------------------------------------------ clear list b
sub clear_list_b:
  for n=4 to 40                                   ' bloque folder
    text 8*29,n*12,space$(69),"L",1,1,white,black
  next n

  text 9*8,45*12,space$(90),"L",1,1,white,black
end sub



'------------------------------------------------ render list a
sub render_list_a:
  cont_a=indice_a

  py=12*4
  if max_listado_a<=limite_a then  
    for n=0 to max_listado_a-1
      text columna_a*8,py,listado_ok_a$(cont_a),"L",1,1,white,black
      cont_a=cont_a+1
      py=py+12
    next n  
  else
    for n=1 to limite_a
      text columna_a*8,py,listado_ok_a$(cont_a),"L",1,1,white,black
      cont_a=cont_a+1
      py=py+12
    next n  
  endif
end sub



'------------------------------------------------ render list b
sub render_list_b:
  cont_b=indice_b
 
  py=12*4
  if max_listado_b<=limite_b then  
    for n=0 to max_listado_b-1
      text columna_b*8,py,listado_ok_b$(cont_b),"L",1,1,white,black
      cont_b=cont_b+1
      py=py+12
    next n  
  else
    for n=1 to limite_b
      text columna_b*8,py,listado_ok_b$(cont_b),"L",1,1,white,black
      cont_b=cont_b+1
      py=py+12
    next n
  endif

  
end sub



'------------------------------------------------ render screen
sub render_screen()
  cls
  text 0,0,space$(100),"L",1,1,black,white
  text 50*8,0,title$,"C",1,1,black,white

  for n=2 to 47
    text 0*8,n*12,chr$(179),"L",1,1,white,black
'    text 8*27,n*12,chr$(179),"L",1,1,white,black
    text 8*99,n*12,chr$(179),"L",1,1,white,black
  next n

  for n=9 to 43
'    text 0,n*12,chr$(179),"L",1,1,white,black
    text 8*27,n*12,chr$(179),"L",1,1,white,black
'    text 8*99,n*12,chr$(179),"L",1,1,white,black
  next n

  text 0,1*12,chr$(218),"L",1,1,white,black
  text 0,3*12,chr$(195),"L",1,1,white,black
    for n=1 to 98
      text n*8,1*12,chr$(196),"L",1,1,white,black
      text n*8,3*12,chr$(196),"L",1,1,white,black
      text n*8,41*12,chr$(196),"L",1,1,white,black
      text n*8,44*12,chr$(196),"L",1,1,white,black
      text n*8,46*12,chr$(196),"L",1,1,white,black
    next n
  text 99*8,1*12,chr$(191),"L",1,1,white,black
  text 99*8,3*12,chr$(180),"L",1,1,white,black

  text 0,48*12,chr$(192),"L",1,1,white,black
    for n=1 to 99
      text n*8,48*12,chr$(196),"L",1,1,white,black
    next n
  text 99*8,48*12,chr$(217),"L",1,1,white,black

  text 0,41*12,chr$(195),"L",1,1,white,black
  text 99*8,41*12,chr$(180),"L",1,1,white,black
  text 99*8,44*12,chr$(180),"L",1,1,white,black
  text 99*8,46*12,chr$(180),"L",1,1,white,black

  text 1*8,2*12,"Current Path:","L",1,1,black,white
'  text 1*8,45*12,"Folder:","L",1,1,black,white

  text 0*8,4*12,"F","L",1,1,black,white
  text 0*8,5*12,"O","L",1,1,black,white
  text 0*8,6*12,"L","L",1,1,black,white
  text 0*8,7*12,"D","L",1,1,black,white
  text 0*8,8*12,"E","L",1,1,black,white
  text 0*8,9*12,"R","L",1,1,black,white
  text 0*8,10*12,"S","L",1,1,black,white

  text 27*8,4*12,"F","L",1,1,black,white
  text 27*8,5*12,"I","L",1,1,black,white
  text 27*8,6*12,"L","L",1,1,black,white
  text 27*8,7*12,"E","L",1,1,black,white
  text 27*8,8*12,"S","L",1,1,black,white

  text 0,44*12,chr$(195),"L",1,1,white,black
  text 0,46*12,chr$(195),"L",1,1,white,black
  text 99*8,44*12,chr$(180),"L",1,1,white,black
  text 99*8,46*12,chr$(180),"L",1,1,white,black
  text 27*8,2*12,chr$(32),"L",1,1,white,black
  text 27*8,3*12,chr$(194),"L",1,1,white,black
  text 27*8,41*12,chr$(197),"L",1,1,white,black
  text 27*8,44*12,chr$(193),"L",1,1,white,black

  text 100*8,49*12,space$(22),"R",1,1,black,white     ' footer
  render_footer()
  
  'BORRA LINEA PATH
  text 8*14,2*12,space$(85),"L",1,1,white,black

  'BORRA INFO NUM FOLDERS
  text 8*1,42*12,space$(26),"L",1,1,white,black
  text 8*1,43*12,space$(26),"L",1,1,white,black

  'BORRA INFO NUM ARCHIVOS
  text 8*28,42*12,space$(71),"L",1,1,white,black
  text 8*28,43*12,space$(71),"L",1,1,white,black


  ' BORRA LINEA INFO FOLDER ACTUAL
  text 9*8,45*12,space$(90),"L",1,1,white,black

  ' BORRA LINEA INFO ARCHIVO ACTUAL
  text 1*8,47*12,space$(98),"L",1,1,white,black  


  text 0*8,49*12," F1 Help ","L",1,1,black,white     ' buttons
  text 10*8,49*12," F9 Reload ","L",1,1,black,white     ' buttons
  text 67*8,49*12," F10 Quit ","L",1,1,black,white     ' buttons
end sub



'------------------------------------------------ render footer
sub render_footer()
  text 8*99,49*12,time$,"R",1,1,black,white     ' footer
  text 8*89,49*12,date$,"R",1,1,black,white     ' footer

  if panel=0 then
'    text 0*8,0*12,"FLDR!","L",1,1,black,white     ' buttons

    text 22*8,49*12," F2 New ","L",1,1,black,white     ' buttons
    
    if listado_ok_a$(indice_a+cursor_a)="<..>" then
      text 31*8,49*12,"           ","L",1,1,white,black     ' buttons
      text 43*8,49*12,"           ","L",1,1,white,black     ' buttons
    else
      text 31*8,49*12," F3 Rename ","L",1,1,black,white     ' buttons
      text 43*8,49*12," F4 Delete ","L",1,1,black,white     ' buttons
    endif

    text 55*8,49*12,"          ","L",1,1,white,black     ' buttons
  else
'    text 0*8,0*12,"FILE!","L",1,1,black,white     ' buttons
    extension$=right$(listado_ok_b$(indice_b+cursor_b),4)
    if extension$=".BAS" or extension$=".bas" then
      text 22*8,49*12," F2 Run ","L",1,1,black,white     ' buttons
    else
      text 22*8,49*12,"        ","L",1,1,white,black     ' buttons
    end if

    if extension$=".BAS" or extension$=".bas" or extension$=".TXT" or extension$=".txt" then
      text 31*8,49*12," F3 Edit ","L",1,1,black,white     ' buttons
    else
      text 31*8,49*12,"         ","L",1,1,white,black     ' buttons
    endif

    if extension$=".BAS" or extension$=".bas" or extension$=".TXT" or extension$=".txt" or extension$=".PNG" or extension$=".png" or extension$=".JPG" or extension$=".jpg" or extension$=".BMP" or extension$=".bmp" then
      text 41*8,49*12," F4 View ","L",1,1,black,white     ' buttons
    else
      text 41*8,49*12,"         ","L",1,1,white,black     ' buttons
    endif

    text 51*8,49*12," F5 Rename ","L",1,1,black,white     ' buttons
  endif
end sub




'------------------------------------------------ clear path
sub clear_path()
    text 8*14,2*12,space$(85),"L",1,1,white,black 
end sub



'------------------------------------------------ render path
sub render_path()
  if carpeta_actual=0 then 'raiz
    text 8*15,2*12,"/","L",1,1,white,black
  else

  posx=8*15
  for n=0 to carpeta_actual-1
    text posx,2*12,"/"+path_completo$(n),"L",1,1,white,black
    posx=posx+(len(path_completo$(n))*8)+8
  next n

  endif
end sub



'------------------------------------------------ pantalla help
sub pantalla_help()
  cls
  text 0,0,title$,"L",1,1,white,black  
  text 0,12,"Help Screen","L",1,1,white,black  

  text 0,3*12,"Current keys:","L",1,1,white,black  
  text 8,4*12,"-Cursors to select.","L",1,1,white,black  
  text 8,5*12,"-Tab to change folders / files.","L",1,1,white,black  
  text 8,6*12,"-Return in folders to change path.","L",1,1,white,black  

  text 0,8*12,"*Some functions may not work.","L",1,1,white,black  
  text 8,9*12,"-Run and edit files.","L",1,1,white,black  
  text 8,10*12,"-View not work correctly with .BAS files.","L",1,1,white,black  
  text 8,11*12,"-View not work correctly with image files.","L",1,1,white,black  
  text 8,12*12,"*Only implemented JPG for now.","L",1,1,white,black  


  text 0,49*12,"Press Return to Main Screen.","L",1,1,white,black  

  loop_pausa:
  if keydown(1)<>10 then
    goto loop_pausa
  endif
end sub

